# PyBelle.py
# Copyright (c) 2012 Marno Cell
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA.

import appuifw2,e32,os,time,topwindow,envy,zipfile,ini,globalui,fgimage
from sysagent import *
from cenrep import *
from sysinfo import *
from appswitch import *
from graphics import *

try: from conmonitor import *
except: appuifw2.note(u'Conmonitor not supported')

appuifw2.app.title=u'Loading...'
pat = 'e:\\system\\apps\\topbar\\'
pgr,gbr,stx = (Image.open(pat+'files\\prg.png'),Image.new((240,320)),36)
fg = fgimage.FGImage()

def splash():
  try:
    for a in range(0,247):
        gbr.clear(0)
        gbr.rectangle((35,186,284,192),0x181717,0x181717)
        if stx < 247:
            gbr.rectangle((36,187,37+stx,191),pattern=pgr)
        else:
            gbr.rectangle((36,187,284,191),pattern=pgr)
        gbr.text((137,174),u'PyBelle',0xffffff,font=(u'Sans MT 936_s60',20))
        gbr.text((192,165),u'\u00ae',0xffffff,font=(u'Sans MT 936_s60',10))
        fg.set(0,0,gbr._bitmapapi())
        e32.ao_sleep(1E-04)
        stx = stx+1
  except:
    pass

splash() #hilangkan tanda (#) didepan (s)untuk menampilkan splash


envy.set_app_hidden(1)
e32.ao_sleep(0,lambda:envy.set_app_hidden(1))
try : envy.set_app_system(1)
except : pass

t0,t1,t2,t3,c0,c1,c2,c3,x0,x1,x2,x3 = 0,100,0,2,6,5,3,1,85.71,57.14,42.85,14.28
u0,u1 = u'Menu',' '
i1 = appuifw2.Icon(unicode(pat+'files\\icon.mbm'),1,0)
i2 = appuifw2.Icon(unicode(pat+'files\\icon.mbm'),2,0)
di = [(u'Wakeup',i2)]
try:
    st = ini.read(pat+'Topbar.ini')
    f0,f1 = (u'Sans MT 936_s60',st['fj']),(u'Sans MT 936_s60',st['ft'])
except:
    st = {'op':u'N.M.B','opx':3,'opy':20,'fj':16,'ft':10,'kx':213,'ky':5,'sx':230,'sy':4,'bx':252,'by':4,'ex':167,'ey':4,'mx':153,'my':4,'cx':276,'cy':20,'tx':3,'ty':20,'ux':215,'uy':16,'gx':195,'gy':5,'ox':185,'oy':4,'px':0,'py':0,'cr':0xffffff,'dr':0x000000,'er':0xffffff,'ap':[u'X-plore',u'Python']}
    f0,f1 = (u'Sans MT 936_s60',16),(u'Sans MT 936_s60',10)
    try:
        ini.write(pat+'Topbar.ini', st)
    except:
       pass

i0 = pat
q0 = Image.open(i0+'tb.png')
b0 = Image.open(i0+'b0.png')
b1 = Image.open(i0+'b1.png')
b2 = Image.open(i0+'b2.png')
b3 = Image.open(i0+'b3.png')
b4 = Image.open(i0+'b4.png')
s0 = Image.open(i0+'s0.png')
s1 = Image.open(i0+'s1.png')
s2 = Image.open(i0+'s2.png')
s3 = Image.open(i0+'s3.png')
s4 = Image.open(i0+'s4.png')
k0 = Image.open(i0+'k0.png')
g4 = Image.open(i0+'3g.png')
o4 = Image.open(i0+'t0.png')
e4 = Image.open(i0+'e0.png')
m4 = Image.open(i0+'m0.png')
img = Image.new((320,58))
win = topwindow.TopWindow()
win.size = (320,37)
win.background_color=t2
win.position = (st['px'], st['py'])

def hide():
    win.hide()

def show():
    win.show()

def hidd():
    switch_to_bg(u'PyBelle')

def about():
    globalui.global_msg_query(u'PyBelle v1.3.1\nBy Marno Cell\nAdmin of: for pys60\n\nSpecial thanks to:\nRamDhanie for the original PyBelle idea.\nMGi and others for their contribution to PyBelle development.\nAll admins & members of: for pys60.\nKeep coding guys \u263a\n\nhttp://m.facebook.com/groups/376405625706616\n\nRegards,\nMarno Cell.', u'About PyBelle')

def quit():
    global rt
    if not appuifw2.query(u'Are you sure?', 'query'):
        return
    rt = 0
    appuifw2.app.set_exit()

def skin():
    hdr = i0+'skins\\'
    zif = []
    alf = os.listdir(hdr)
    for j in alf:
        if j.lower().endswith('.zip'): zif.append(u''+j)
    cse = appuifw2.selection_list(zif,1)
    if cse == None:
        return None
    try:
        appuifw2.note(u'Please wait...')
        a = zipfile.ZipFile(hdr+zif[cse],'r')
        for i in a.namelist():
            b = open(i0+i,'wb')
            b.write(a.read(i))
            b.close()
        quit()
    except Exception, err:
        appuifw2.note(u''+str(err),'error')

def handler():
    global lb,di
    pa = di[lb.current()][0]
    if pa == 'Sleep':
        di=[(u'Wakeup',i2)]
        show()
    if pa == 'Wakeup':
        di=[(u'Sleep',i1)]
        hide()
    else:
        pass
    lb.set_list(di,handler)

lb = appuifw2.Listbox(di,handler)
appuifw2.app.body = lb
appuifw2.app.title = u'PyBelle'
appuifw2.app.navi_text = u'v1.31'
appuifw2.app.menu_key_text = u' Menu'
appuifw2.app.exit_key_text = u'Hide '
appuifw2.app.exit_key_handler = hidd
appuifw2.app.menu = [(u'Change skin', skin), (u'About', about), (u'Exit', quit)]
fg.unset()
del fgimage
show()

rt = 1
while rt:
    ac = application_list(1)[0]
    dt = unicode(time.strftime('%d/%m/%Y'))
    cl = unicode(time.strftime('%H:%M'))
    sn = signal()
    br = battery()
    bt = bt_powerstate()
    ie = get_inbox_status()
    mk = new_missed_calls()
    img.rectangle((0,0,320,21),pattern=q0)
    img.blit(k0,target=(st['kx'],st['ky']))

    try:
     gs = get()
     if gs>=c3:
      img.blit(g4,target=(st['gx'],st['gy']))
    except: pass

    if bt>=c3:
        img.blit(o4,target=(st['ox'],st['oy']))
    if ie>=t3:
        img.blit(e4,target=(st['ex'],st['ey']))
    if mk>=c3:
        img.blit(m4,target=(st['mx'],st['my']))
    if sn>=c0:
        img.blit(s4,target=(st['sx'],st['sy']))
    elif sn>=c1:
        img.blit(s3,target=(st['sx'],st['sy']))
    elif sn>=c2:
        img.blit(s2,target=(st['sx'],st['sy']))
    elif sn>=c3:
        img.blit(s1,target=(st['sx'],st['sy']))
    else:
        img.blit(s0,target=(st['sx'],st['sy']))
    if br>=x0:
        img.blit(b4,target=(st['bx'],st['by']))
    elif br>=x1:
        img.blit(b3,target=(st['bx'],st['by']))
    elif br>=x2:
        img.blit(b2,target=(st['bx'],st['by']))
    elif br>=x3:
        img.blit(b1,target=(st['bx'],st['by']))
    else:
        img.blit(b0,target=(st['bx'],st['by']))
    if ac==u1:
        img.text((st['tx'],st['ty']),u0,st['cr'],f0)
    if ac in st['ap']:
        win.position = (321,0)
    else:
        if len(ac)>=12:
            img.text((st['tx'],st['ty']),ac[:12],st['cr'],f0)
        else:
            img.text((st['tx'],st['ty']),ac,st['cr'],f0)
        win.position = (st['px'], st['py'])
    img.text((st['opx'],st['opy']),unicode(st['op']),st['cr'],f0)
    img.text((st['cx'],st['cy']),cl,st['er'],f0)
    img.text((st['ux'],st['uy']),dt,st['dr'],f1)
    win.add_image(img,(t2,t2))
    e32.ao_sleep(c3)
    if t0>=t1:
        t0=0
        win.remove_image(img)
    t0=t0+1
